var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Strings_1 = require("../Strings");
var XmlNamespace_1 = require("../Enumerations/XmlNamespace");
var ExtensionMethods_1 = require("../ExtensionMethods");
var EwsLogging_1 = require("../Core/EwsLogging");
var ComplexProperty_1 = require("./ComplexProperty");
var ComplexPropertyCollection = (function (_super) {
    __extends(ComplexPropertyCollection, _super);
    function ComplexPropertyCollection() {
        _super.apply(this, arguments);
        this.___implementsInterface = ["ISelfValidate", "IJsonSerializable", "IEnumerable<TComplexProperty>", "ICustomUpdateSerializer", "IJsonCollectionDeserialize"];
        this.___typeName = "ComplexPropertyCollection";
        this.___typeGenerics = ["ComplexProperty"];
        //Item: TComplexProperty;
        this.items = []; //System.Collections.Generic.List<TComplexProperty>;
        this.addedItems = []; //System.Collections.Generic.List<TComplexProperty>;
        this.modifiedItems = []; //System.Collections.Generic.List<TComplexProperty>;
        this.removedItems = []; //System.Collections.Generic.List<TComplexProperty>;
    }
    Object.defineProperty(ComplexPropertyCollection.prototype, "Items", {
        get: function () { return this.items; } //System.Collections.Generic.List<TComplexProperty>;
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ComplexPropertyCollection.prototype, "AddedItems", {
        get: function () { return this.addedItems; } //System.Collections.Generic.List<TComplexProperty>;
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ComplexPropertyCollection.prototype, "ModifiedItems", {
        get: function () { return this.modifiedItems; } //System.Collections.Generic.List<TComplexProperty>;
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ComplexPropertyCollection.prototype, "RemovedItems", {
        get: function () { return this.removedItems; } //System.Collections.Generic.List<TComplexProperty>;
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ComplexPropertyCollection.prototype, "Count", {
        get: function () { return this.items.length; },
        enumerable: true,
        configurable: true
    });
    ComplexPropertyCollection.prototype.__thisIndexer = function (index) {
        if (index < 0 || index >= this.Count) {
            throw new Error("ComplexPropertyCollection[index] (__thisIndexer) : " + Strings_1.Strings.IndexIsOutOfRange); // ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
        }
        return this.items[index];
    };
    ComplexPropertyCollection.prototype.ClearChangeLog = function () {
        this.removedItems.splice(0);
        this.addedItems.splice(0);
        this.modifiedItems.splice(0);
    };
    ComplexPropertyCollection.prototype.Contains = function (complexProperty) { return this.items.indexOf(complexProperty) >= 0; };
    ComplexPropertyCollection.prototype.CreateComplexProperty = function (xmlElementName) { throw new Error("abstract - ComplexPropertyCollection.ts - CreateComplexProperty : Not implemented."); };
    ComplexPropertyCollection.prototype.CreateDefaultComplexProperty = function () { throw new Error("abstract - ComplexPropertyCollection.ts - CreateDefaultComplexProperty : Not implemented."); };
    ComplexPropertyCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) { throw new Error("abstract - ComplexPropertyCollection.ts - GetCollectionItemXmlElementName : Not implemented."); };
    //GetEnumerator(): any { throw new Error("ComplexPropertyCollection.ts - GetEnumerator : Not implemented."); }
    ComplexPropertyCollection.prototype.IndexOf = function (complexProperty) { return this.items.indexOf(complexProperty); };
    //InternalAdd(complexProperty: TComplexProperty): any { throw new Error("ComplexPropertyCollection.ts - InternalAdd : Not implemented."); }
    ComplexPropertyCollection.prototype.InternalAdd = function (complexProperty, loading) {
        if (loading === void 0) { loading = false; }
        EwsLogging_1.EwsLogging.Assert(complexProperty != null, "ComplexPropertyCollection.InternalAdd", "complexProperty is null");
        if (this.items.indexOf(complexProperty) < 0) {
            this.items.push(complexProperty);
            if (!loading) {
                ExtensionMethods_1.ArrayHelper.RemoveEntry(this.removedItems, complexProperty); // this.removedItems.Remove(complexProperty);
                this.addedItems.push(complexProperty);
            }
            complexProperty.OnChange.push(this.ItemChanged);
            this.Changed();
        }
    };
    ComplexPropertyCollection.prototype.InternalClear = function () {
        while (this.Count > 0) {
            this.InternalRemoveAt(0);
        }
    };
    ComplexPropertyCollection.prototype.InternalRemove = function (complexProperty) {
        EwsLogging_1.EwsLogging.Assert(complexProperty != null, "ComplexPropertyCollection.InternalRemove", "complexProperty is null");
        if (ExtensionMethods_1.ArrayHelper.RemoveEntry(this.items, complexProperty)) {
            ExtensionMethods_1.ArrayHelper.RemoveEntry(complexProperty.OnChange, this.ItemChanged); // complexProperty.OnChange -= this.ItemChanged;
            if (this.addedItems.indexOf(complexProperty) < 0) {
                this.removedItems.push(complexProperty);
            }
            else {
                ExtensionMethods_1.ArrayHelper.RemoveEntry(this.addedItems, complexProperty); // this.addedItems.Remove(complexProperty);
            }
            ExtensionMethods_1.ArrayHelper.RemoveEntry(this.modifiedItems, complexProperty); // this.modifiedItems.Remove(complexProperty);
            this.Changed();
            return true;
        }
        else {
            return false;
        }
    };
    ComplexPropertyCollection.prototype.InternalRemoveAt = function (index) {
        EwsLogging_1.EwsLogging.Assert(index >= 0 && index < this.Count, "ComplexPropertyCollection.InternalRemoveAt", "index is out of range.");
        this.InternalRemove(this.items[index]);
    };
    ComplexPropertyCollection.prototype.InternalToJson = function (service) { throw new Error("ComplexPropertyCollection.ts - InternalToJson : Not implemented."); };
    ComplexPropertyCollection.prototype.ItemChanged = function (complexProperty) {
        //TComplexProperty property = complexProperty as TComplexProperty;
        var property = complexProperty;
        // EwsLogging.Assert(
        //     property != null,
        //     "ComplexPropertyCollection.ItemChanged",
        //     StringHelper.Format("ComplexPropertyCollection.ItemChanged: the type of the complexProperty argument ({0}) is not supported.", complexProperty.___typeName));
        if (this.addedItems.indexOf(property) < 0) {
            if (this.modifiedItems.indexOf(property) < 0) {
                this.modifiedItems.push(property);
                this.Changed();
            }
        }
    };
    ComplexPropertyCollection.prototype.LoadFromXmlJsObject = function (jsObject, service) { throw new Error("ComplexPropertyCollection.ts - LoadFromXmlJsObject : Not implemented."); };
    //LoadFromXml(reader: EwsServiceXmlReader, localElementName: string): any { throw new Error("ComplexPropertyCollection.ts - LoadFromXml : Not implemented."); }
    ComplexPropertyCollection.prototype.RemoveFromChangeLog = function (complexProperty) {
        ExtensionMethods_1.ArrayHelper.RemoveEntry(this.removedItems, complexProperty); //this.removedItems.Remove(complexProperty);
        ExtensionMethods_1.ArrayHelper.RemoveEntry(this.modifiedItems, complexProperty); //this.modifiedItems.Remove(complexProperty);
        ExtensionMethods_1.ArrayHelper.RemoveEntry(this.addedItems, complexProperty); //this.addedItems.Remove(complexProperty);
    };
    ComplexPropertyCollection.prototype.ShouldWriteToRequest = function () {
        // Only write collection if it has at least one element.
        return this.Count > 0;
    };
    ComplexPropertyCollection.prototype.UpdateFromXmlJsObject = function (jsObject, service) { throw new Error("ComplexPropertyCollection.ts - UpdateFromXmlJsObject : Not implemented."); };
    ComplexPropertyCollection.prototype.WriteElementsToXml = function (writer) {
        for (var _i = 0, _a = this.items; _i < _a.length; _i++) {
            var complexProperty = _a[_i];
            complexProperty.WriteToXml(writer, this.GetCollectionItemXmlElementName(complexProperty));
        }
    };
    ComplexPropertyCollection.prototype.WriteToXml = function (writer, xmlElementName, xmlNamespace) {
        if (xmlNamespace === void 0) { xmlNamespace = XmlNamespace_1.XmlNamespace.Types; }
        if (this.ShouldWriteToRequest()) {
            _super.prototype.WriteToXml.call(this, writer, xmlElementName, xmlNamespace);
        }
    };
    //ICustomUpdateSerializer
    ComplexPropertyCollection.prototype.WriteSetUpdateToXml = function (writer, ewsObject, propertyDefinition) {
        // If the collection is empty, delete the property.
        if (this.Count == 0) {
            writer.WriteStartElement(XmlNamespace_1.XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
            propertyDefinition.WriteToXml(writer);
            writer.WriteEndElement();
            return true;
        }
        else {
            return false;
        }
    };
    ComplexPropertyCollection.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
        // Use the default XML serializer.
        return false;
    };
    return ComplexPropertyCollection;
})(ComplexProperty_1.ComplexProperty);
exports.ComplexPropertyCollection = ComplexPropertyCollection;
