var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var XmlElementNames_1 = require("../../XmlElementNames");
var GenericPropertyDefinition_1 = require("../../../PropertyDefinitions/GenericPropertyDefinition");
var ExchangeVersion_1 = require("../../../Enumerations/ExchangeVersion");
var PropertyDefinitionFlags_1 = require("../../../Enumerations/PropertyDefinitionFlags");
var ComplexPropertyDefinition_1 = require("../../../PropertyDefinitions/ComplexPropertyDefinition");
var ChangeHighlights_1 = require("../../../ComplexProperties/ChangeHighlights");
var AppointmentSchema_1 = require("./AppointmentSchema");
var MeetingMessageSchema_1 = require("./MeetingMessageSchema");
//module MeetingRequestSchema {
var FieldUris;
(function (FieldUris) {
    FieldUris.MeetingRequestType = "meetingRequest:MeetingRequestType";
    FieldUris.IntendedFreeBusyStatus = "meetingRequest:IntendedFreeBusyStatus";
    FieldUris.ChangeHighlights = "meetingRequest:ChangeHighlights";
})(FieldUris || (FieldUris = {}));
//}
var MeetingRequestSchema = (function (_super) {
    __extends(MeetingRequestSchema, _super);
    function MeetingRequestSchema() {
        _super.apply(this, arguments);
    }
    MeetingRequestSchema.prototype.RegisterProperties = function () {
        _super.prototype.RegisterProperties.call(this);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingRequestType);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IntendedFreeBusyStatus);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ChangeHighlights);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Start);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.End);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.OriginalStart);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsAllDayEvent);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.LegacyFreeBusyStatus);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Location);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.When);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsMeeting);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsCancelled);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsRecurring);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingRequestWasSent);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentType);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MyResponseType);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Organizer);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.RequiredAttendees);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.OptionalAttendees);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Resources);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConflictingMeetingCount);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AdjacentMeetingCount);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConflictingMeetings);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AdjacentMeetings);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Duration);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.TimeZone);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentReplyTime);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentSequenceNumber);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentState);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Recurrence);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.FirstOccurrence);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.LastOccurrence);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ModifiedOccurrences);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.DeletedOccurrences);
        _super.prototype.RegisterInternalProperty.call(this, MeetingRequestSchema.MeetingTimeZone);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.StartTimeZone);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.EndTimeZone);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConferenceType);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AllowNewTimeProposal);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsOnlineMeeting);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingWorkspaceUrl);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.NetShowUrl);
        _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.EnhancedLocation);
    };
    MeetingRequestSchema.MeetingRequestType = new GenericPropertyDefinition_1.GenericPropertyDefinition("MeetingRequestType", XmlElementNames_1.XmlElementNames.MeetingRequestType, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.MeetingRequestType);
    MeetingRequestSchema.IntendedFreeBusyStatus = new GenericPropertyDefinition_1.GenericPropertyDefinition("IntendedFreeBusyStatus", XmlElementNames_1.XmlElementNames.IntendedFreeBusyStatus, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.IntendedFreeBusyStatus, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    MeetingRequestSchema.ChangeHighlights = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ChangeHighlights", XmlElementNames_1.XmlElementNames.ChangeHighlights, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.ChangeHighlights, PropertyDefinitionFlags_1.PropertyDefinitionFlags.None, function () { return new ChangeHighlights_1.ChangeHighlights(); });
    MeetingRequestSchema.EnhancedLocation = AppointmentSchema_1.AppointmentSchema.Instance.EnhancedLocation;
    MeetingRequestSchema.Start = AppointmentSchema_1.AppointmentSchema.Instance.Start;
    MeetingRequestSchema.End = AppointmentSchema_1.AppointmentSchema.Instance.End;
    MeetingRequestSchema.OriginalStart = AppointmentSchema_1.AppointmentSchema.Instance.OriginalStart;
    MeetingRequestSchema.IsAllDayEvent = AppointmentSchema_1.AppointmentSchema.Instance.IsAllDayEvent;
    MeetingRequestSchema.LegacyFreeBusyStatus = AppointmentSchema_1.AppointmentSchema.Instance.LegacyFreeBusyStatus;
    MeetingRequestSchema.Location = AppointmentSchema_1.AppointmentSchema.Instance.Location;
    MeetingRequestSchema.When = AppointmentSchema_1.AppointmentSchema.Instance.When;
    MeetingRequestSchema.IsMeeting = AppointmentSchema_1.AppointmentSchema.Instance.IsMeeting;
    MeetingRequestSchema.IsCancelled = AppointmentSchema_1.AppointmentSchema.Instance.IsCancelled;
    MeetingRequestSchema.IsRecurring = AppointmentSchema_1.AppointmentSchema.Instance.IsRecurring;
    MeetingRequestSchema.MeetingRequestWasSent = AppointmentSchema_1.AppointmentSchema.Instance.MeetingRequestWasSent;
    MeetingRequestSchema.AppointmentType = AppointmentSchema_1.AppointmentSchema.Instance.AppointmentType;
    MeetingRequestSchema.MyResponseType = AppointmentSchema_1.AppointmentSchema.Instance.MyResponseType;
    MeetingRequestSchema.Organizer = AppointmentSchema_1.AppointmentSchema.Instance.Organizer;
    MeetingRequestSchema.RequiredAttendees = AppointmentSchema_1.AppointmentSchema.Instance.RequiredAttendees;
    MeetingRequestSchema.OptionalAttendees = AppointmentSchema_1.AppointmentSchema.Instance.OptionalAttendees;
    MeetingRequestSchema.Resources = AppointmentSchema_1.AppointmentSchema.Instance.Resources;
    MeetingRequestSchema.ConflictingMeetingCount = AppointmentSchema_1.AppointmentSchema.Instance.ConflictingMeetingCount;
    MeetingRequestSchema.AdjacentMeetingCount = AppointmentSchema_1.AppointmentSchema.Instance.AdjacentMeetingCount;
    MeetingRequestSchema.ConflictingMeetings = AppointmentSchema_1.AppointmentSchema.Instance.ConflictingMeetings;
    MeetingRequestSchema.AdjacentMeetings = AppointmentSchema_1.AppointmentSchema.Instance.AdjacentMeetings;
    MeetingRequestSchema.Duration = AppointmentSchema_1.AppointmentSchema.Instance.Duration;
    MeetingRequestSchema.TimeZone = AppointmentSchema_1.AppointmentSchema.Instance.TimeZone;
    MeetingRequestSchema.AppointmentReplyTime = AppointmentSchema_1.AppointmentSchema.Instance.AppointmentReplyTime;
    MeetingRequestSchema.AppointmentSequenceNumber = AppointmentSchema_1.AppointmentSchema.Instance.AppointmentSequenceNumber;
    MeetingRequestSchema.AppointmentState = AppointmentSchema_1.AppointmentSchema.Instance.AppointmentState;
    MeetingRequestSchema.Recurrence = AppointmentSchema_1.AppointmentSchema.Instance.Recurrence;
    MeetingRequestSchema.FirstOccurrence = AppointmentSchema_1.AppointmentSchema.Instance.FirstOccurrence;
    MeetingRequestSchema.LastOccurrence = AppointmentSchema_1.AppointmentSchema.Instance.LastOccurrence;
    MeetingRequestSchema.ModifiedOccurrences = AppointmentSchema_1.AppointmentSchema.Instance.ModifiedOccurrences;
    MeetingRequestSchema.DeletedOccurrences = AppointmentSchema_1.AppointmentSchema.Instance.DeletedOccurrences;
    MeetingRequestSchema.MeetingTimeZone = AppointmentSchema_1.AppointmentSchema.Instance.MeetingTimeZone;
    MeetingRequestSchema.StartTimeZone = AppointmentSchema_1.AppointmentSchema.Instance.StartTimeZone;
    MeetingRequestSchema.EndTimeZone = AppointmentSchema_1.AppointmentSchema.Instance.EndTimeZone;
    MeetingRequestSchema.ConferenceType = AppointmentSchema_1.AppointmentSchema.Instance.ConferenceType;
    MeetingRequestSchema.AllowNewTimeProposal = AppointmentSchema_1.AppointmentSchema.Instance.AllowNewTimeProposal;
    MeetingRequestSchema.IsOnlineMeeting = AppointmentSchema_1.AppointmentSchema.Instance.IsOnlineMeeting;
    MeetingRequestSchema.MeetingWorkspaceUrl = AppointmentSchema_1.AppointmentSchema.Instance.MeetingWorkspaceUrl;
    MeetingRequestSchema.NetShowUrl = AppointmentSchema_1.AppointmentSchema.Instance.NetShowUrl;
    MeetingRequestSchema.Instance = new MeetingRequestSchema();
    return MeetingRequestSchema;
})(MeetingMessageSchema_1.MeetingMessageSchema);
exports.MeetingRequestSchema = MeetingRequestSchema;
