var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var PropertyDefinitionFlags_1 = require("../Enumerations/PropertyDefinitionFlags");
var PropertyDefinition_1 = require("./PropertyDefinition");
var ComplexPropertyDefinitionBase = (function (_super) {
    __extends(ComplexPropertyDefinitionBase, _super);
    function ComplexPropertyDefinitionBase(propertyName, xmlElementName, version, uri, flags) {
        _super.call(this, propertyName, xmlElementName, version, uri, flags);
    }
    ComplexPropertyDefinitionBase.prototype.CreatePropertyInstance = function (owner) { throw new Error("ComplexPropertyDefinitionBase.ts - CreatePropertyInstance : Abstract method - Not implemented."); };
    ComplexPropertyDefinitionBase.prototype.GetPropertyInstance = function (propertyBag, complexProperty) {
        complexProperty.outValue = null;
        if (!propertyBag.TryGetValue(this, complexProperty) || !this.HasFlag(PropertyDefinitionFlags_1.PropertyDefinitionFlags.ReuseInstance, propertyBag.Owner.Service.RequestedServerVersion)) {
            complexProperty.outValue = this.CreatePropertyInstance(propertyBag.Owner);
            return true;
        }
        return false;
    };
    ComplexPropertyDefinitionBase.prototype.InternalLoadCollectionFromJson = function (jsonCollection, service, propertyBag) { throw new Error("ComplexPropertyDefinitionBase.ts - InternalLoadCollectionFromJson : Not implemented."); };
    ComplexPropertyDefinitionBase.prototype.InternalLoadFromJson = function (jsonObject /*JsonObject*/, service, propertyBag) { throw new Error("ComplexPropertyDefinitionBase.ts - InternalLoadFromJson : Not implemented."); };
    ComplexPropertyDefinitionBase.prototype.InternalLoadFromXmlJsObject = function (jsObject, service, propertyBag) {
        var outComplexproperty = { outValue: null };
        var justCreated = this.GetPropertyInstance(propertyBag, outComplexproperty);
        if (!justCreated && this.HasFlag(PropertyDefinitionFlags_1.PropertyDefinitionFlags.UpdateCollectionItems, propertyBag.Owner.Service.RequestedServerVersion)) {
            outComplexproperty.outValue.UpdateFromXmlJsObject(jsObject, null /*reader.LocalName*/);
        }
        else {
            //var typename = TypeSystem.GetJsObjectTypeName(jsObject);
            outComplexproperty.outValue.LoadFromXmlJsObject(jsObject, service);
        }
        propertyBag._setItem(this, outComplexproperty.outValue);
    };
    //LoadPropertyValueFromJson(value: any, service: ExchangeService, propertyBag: PropertyBag): any { throw new Error("ComplexPropertyDefinitionBase.ts - LoadPropertyValueFromJson : Not implemented."); }
    ComplexPropertyDefinitionBase.prototype.LoadPropertyValueFromXmlJsObject = function (jsObject, service, propertyBag) {
        debugger; //todo: check for array type.
        this.InternalLoadFromXmlJsObject(jsObject, service, propertyBag);
        //    reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, this.XmlElementName);
        //
        //if (!reader.IsEmptyElement || reader.HasAttributes)
        //{
        //    this.InternalLoadFromXml(reader, propertyBag);
        //}
        //
        //reader.ReadEndElementIfNecessary(XmlNamespace.Types, this.XmlElementName);
    };
    //WriteJsonValue(jsonObject: any /*JsonObject*/, propertyBag: PropertyBag, service: ExchangeService, isUpdateOperation: boolean): any { throw new Error("ComplexPropertyDefinitionBase.ts - WriteJsonValue : Not implemented."); }
    ComplexPropertyDefinitionBase.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        var complexProperty = propertyBag._getItem(this);
        debugger;
        if (complexProperty != null || typeof complexProperty !== 'undefined') {
            complexProperty.WriteToXml(writer, this.XmlElementName);
        }
        //throw new Error("ComplexPropertyDefinitionBase.ts - WritePropertyValueToXml : Not implemented."); 
    };
    return ComplexPropertyDefinitionBase;
})(PropertyDefinition_1.PropertyDefinition);
exports.ComplexPropertyDefinitionBase = ComplexPropertyDefinitionBase;
