var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var PropertyException_1 = require("../Exceptions/PropertyException");
var Strings_1 = require("../Strings");
var XmlNamespace_1 = require("../Enumerations/XmlNamespace");
var EwsUtilities_1 = require("../Core/EwsUtilities");
var DateTime_1 = require("../DateTime");
var ExtensionMethods_1 = require("../ExtensionMethods");
var PropertyDefinition_1 = require("./PropertyDefinition");
var DateTimePropertyDefinition = (function (_super) {
    __extends(DateTimePropertyDefinition, _super);
    function DateTimePropertyDefinition(propertyName, xmlElementName, version, uri, flags, isNullable) {
        if (isNullable === void 0) { isNullable = false; }
        _super.call(this, propertyName, xmlElementName, version, uri, flags);
        this.isNullable = false;
    }
    Object.defineProperty(DateTimePropertyDefinition.prototype, "IsNullable", {
        get: function () { return this.isNullable; },
        enumerable: true,
        configurable: true
    });
    DateTimePropertyDefinition.prototype.GetConvertedDateTime = function (service, propertyBag, isUpdateOperation, value) {
        var dateTime = DateTime_1.DateTime.Parse(value);
        var convertedDateTime;
        debugger; //todo:find datetimekind
        // If the date/time is unspecified, we may need to scope it to time zone.
        if (dateTime.Kind == DateTime_1.DateTimeKind.Unspecified) {
            convertedDateTime = this.ScopeToTimeZone(service, value, propertyBag, isUpdateOperation);
        }
        else {
            convertedDateTime = dateTime;
        }
        return convertedDateTime;
    };
    DateTimePropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) { throw new Error("DateTimePropertyDefinition.ts - LoadPropertyValueFromJson : Not implemented."); };
    DateTimePropertyDefinition.prototype.LoadPropertyValueFromXmlJsObject = function (jsObject, service, propertyBag) {
        var stringValue = jsObject; //.toString();
        debugger; //check for datetime value
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(stringValue)) {
            var value = service.ConvertUniversalDateTimeStringToLocalDateTime(stringValue);
            propertyBag._setItem(this, service.ConvertUniversalDateTimeStringToLocalDateTime(stringValue));
        }
    };
    DateTimePropertyDefinition.prototype.ScopeToTimeZone = function (service, dateTime, propertyBag, isUpdateOperation) {
        try {
            var convertedDateTime = EwsUtilities_1.EwsUtilities.ConvertTime(dateTime, service.TimeZone, DateTime_1.TimeZoneInfo.Utc);
            return new DateTime_1.DateTime(convertedDateTime, DateTime_1.DateTimeKind.Utc);
        }
        catch (e) {
            throw new PropertyException_1.PropertyException(ExtensionMethods_1.StringHelper.Format(Strings_1.Strings.InvalidDateTime, dateTime), this.Name, e);
        }
    };
    DateTimePropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) { throw new Error("DateTimePropertyDefinition.ts - WriteJsonValue : Not implemented."); };
    DateTimePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        var value = propertyBag._getItem(this);
        if (value != null) {
            writer.WriteStartElement(XmlNamespace_1.XmlNamespace.Types, this.XmlElementName);
            var convertedDateTime = this.GetConvertedDateTime(writer.Service, propertyBag, isUpdateOperation, value);
            writer.WriteValue(EwsUtilities_1.EwsUtilities.DateTimeToXSDateTime(convertedDateTime), this.Name);
            writer.WriteEndElement();
        }
    };
    return DateTimePropertyDefinition;
})(PropertyDefinition_1.PropertyDefinition);
exports.DateTimePropertyDefinition = DateTimePropertyDefinition;
